config/routes.rb
Rails.application.routes.draw do
  ####### BEGIN: Staff ########
  namespace :staffs do
    get 'sign_in', to: 'sessions#new'
    resource  :sessions, only: %i[create destroy]
    resources :dashboard, only: %i[index]
    resource  :account, only: %i[show update], controller: :account do
      patch 'update_password'
      patch 'update_avatar'
    end

    root 'dashboard#index'
  end
end

app/controllers/staffs/account_controller.rb
# frozen_string_literal: true

module Staffs
  class AccountController < BaseController
    def show; end

    def update
      current_staff.update! updating_params
      notify :success, I18n.t('notifications.account.updated_successfully'), now: true
    end

    def update_password
      service = ::Account::ChangingPasswordService.new(updating_password_params)
      service.of_record(current_staff).change!
      notify :success, t('notifications.account.updated_password_successfully'), now: true
      @updated = true
    ensure
      current_staff.errors.merge! service.errors
    end

    def update_avatar
      service = Account::UpdatingAvatarService.new(current_staff, updating_avatar_params)
      service.execute!
      notify :success, t('notifications.account.updated_avatar_successfully'), now: true
      @updated = true
    ensure
      @staff = service.record
    end

    private

    def updating_params
      params.require(:staff)
            .permit(:first_name, :last_name, :birthdate, :phone_number, :address)
    end

    def updating_password_params
      params.permit(:old_password, :password, :password_confirmation)
    end

    def updating_avatar_params
      params.permit(:avatar, :offset_x, :offset_y, :width, :height)
    end
  end
end

app/helpers/staffs/account_helper.rb
# frozen_string_literal: true

module Staffs::AccountHelper
end

app/views/staffs/account/partials/_form_account.html.slim
.card
  .card-header
    h5.card-title.mb-0
      = t('labels.account.basic_information')

  .card-body.pt-0
    = form_with model: staff, url: staffs_account_path, local: false,
                data: { confirm: t('confirmations.account.update') } do |f|
      fieldset
        / Field: Email
        .form-group.mb-3
          label.control-label = Staff.human_attribute_name :email
          = f.text_field :email, autocomplete: 'off', id: nil, class: 'form-control', maxlength: 255, disabled: true

        .row
          .col-6
            / Field: First name
            .form-group.mb-3 class=('has-error' if f.object.errors.key?(:first_name))
              label.control-label.label--required = Staff.human_attribute_name :first_name
              = f.text_field :first_name, autocomplete: 'off', id: nil, class: 'form-control', maxlength: 255
              = error_messages_of f.object, :first_name if f.object.errors.key?(:first_name)

          .col-6
            / Field: Last name
            .form-group.mb-3 class=('has-error' if f.object.errors.key?(:last_name))
              label.control-label.label--required = Staff.human_attribute_name :last_name
              = f.text_field :last_name, autocomplete: 'off', id: nil, class: 'form-control', maxlength: 255
              = error_messages_of f.object, :last_name if f.object.errors.key?(:last_name)

        / Field: Birthdate
        .form-group.mb-3 class=('has-error' if f.object.errors.key?(:birthdate))
          label.control-label = Staff.human_attribute_name :birthdate
          = f.text_field :birthdate, autocomplete: 'off', id: nil, class: 'form-control js-datepicker',
                                     placeholder: t('pickers.texts.date'),
                                     value: l(f.object.birthdate, format: :date_only, default: ''),
                                     data: { 'picker-orientation': 'bottom auto' }
                                     maxlength: 255
          = error_messages_of f.object, :birthdate if f.object.errors.key?(:birthdate)

        / / Field: Phone number
        .form-group.mb-3 class=('has-error' if f.object.errors.key?(:phone_number))
          label.control-label = Staff.human_attribute_name :phone_number
          = f.text_field :phone_number, autocomplete: 'off', id: nil, class: 'form-control', maxlength: 255
          = error_messages_of f.object, :phone_number if f.object.errors.key?(:phone_number)

        / Field: Address
        .form-group.mb-3 class=('has-error' if f.object.errors.key?(:address))
          label.control-label = Staff.human_attribute_name :address
          = f.text_field :address, autocomplete: 'off', id: nil, class: 'form-control', maxlength: 255
          = error_messages_of f.object, :address if f.object.errors.key?(:address)

        / Field: Role
        .form-group.mb-3
          label.control-label = Staff.human_attribute_name :role
          = f.text_field :role, autocomplete: 'off', id: nil, class: 'form-control', maxlength: 255, disabled: true,
                                value: Staff.human_attribute_name("role.#{f.object.role}")

      button.btn.btn-primary type='submit'
        = t('actions.save_changes')

app/views/staffs/account/partials/_form_avatar.html.slim
.card
  .card-header
    h5.card-title.mb-0
      = t('labels.account.avatar')

  .card-body.pt-0
    = form_tag update_avatar_staffs_account_path, multipart: true,
               class: 'js-imageCropper-wrapper', remote: true, method: :patch,
               data: { confirm: t('confirmations.account.update_avatar') } do
      fieldset
        / Block: Info
        .js-avatar-info.d-none
          = render_announcements :info, t('announcements.account.avatar_will_be_resize_to_size', size: Settings.image.avatar_size)

        / Block: Announcements
        .js-avatar-announcements

        / Block: Preview Image
        .js-imageCropper-imageWrapper.mb-4.text-center
          = image_tag staff.avatar_image, class: 'js-imageCropper-image mw-100',
                                          data: { 'aspect-ratio': '1',
                                                  'start-size': '100|100|px',
                                                  'min-size': '100|100|px' }

        / Block: Cropping data
        = hidden_field_tag :offset_x, nil, { class: 'js-imageCropper-offsetX', id: nil }
        = hidden_field_tag :offset_y, nil, { class: 'js-imageCropper-offsetY', id: nil }
        = hidden_field_tag :width, nil, { class: 'js-imageCropper-width', id: nil }
        = hidden_field_tag :height, nil, { class: 'js-imageCropper-height', id: nil }

        / Button: Edit
        button.js-imageCropper-btnEdit.btn.btn-primary type='button'
          = t('actions.edit')

        .js-imageCropper-editGroup.d-flex.flex-1.d-none
          / Button: Cancel
          button.js-imageCropper-btnCancel.btn.btn-secondary.flex-shrink-0 type='button'
            = t('actions.cancel')

          .input-group.justify-content-end
            / Field: File
            label.js-imageCropper-btnChoose.btn.btn-light.border(
              for='#js-imageCropper-chooseFileInput'
              data-label-choose=t('actions.file.choose')
              data-label-chosen=t('actions.file.chosen')
            )
              = t('actions.file.choose')
            = file_field_tag :avatar, class: 'js-imageCropper-imageInput d-none',
                                      id: '#js-imageCropper-chooseFileInput',
                                      accept: ['image/png', 'image/jpg', 'image/jpeg'],
                                      data: { 'available-mimetypes': 'image/png|image/jpg|image/jpeg' }

            / Button: Save
            = button_tag nil, class: 'js-imageCropper-btnSave btn btn-primary', disabled: true do
              = t('actions.save_changes')

app/views/staffs/account/partials/_form_password.html.slim
.card
  .card-header
    h5.card-title.mb-0
      = t('labels.account.change_password')

  .card-body.pt-0
    = form_tag update_password_staffs_account_path, method: :patch, remote: true,
               data: { confirm: t('confirmations.account.update_password') } do
      fieldset
        / Field: Old password
        .form-group.mb-3 class=('has-error' if staff.errors.key?(:old_password))
          label.control-label = Staff.human_attribute_name :old_password
          = password_field_tag :old_password, params[:old_password], autocomplete: 'off', id: nil,
                                              class: 'js-password-old_pasword form-control', maxlength: 255
          = error_messages_of staff, :old_password if staff.errors.key?(:old_password)

        / Field: New password
        .form-group.mb-3 class=('has-error' if staff.errors.key?(:password))
          label.control-label = Staff.human_attribute_name :password
          = password_field_tag :password, params[:password], autocomplete: 'off', id: nil,
                                          class: 'js-password-pasword form-control', maxlength: 255
          = error_messages_of staff, :password if staff.errors.key?(:password)

        / Field: New password confirmation
        .form-group.mb-3 class=('has-error' if staff.errors.key?(:password_confirmation))
          label.control-label = Staff.human_attribute_name :password_confirmation
          = password_field_tag :password_confirmation, params[:password_confirmation], autocomplete: 'off', id: nil,
                                                       class: 'js-password-pasword_confirmation form-control', maxlength: 255
          = error_messages_of staff, :password_confirmation if staff.errors.key?(:password_confirmation)

      button.btn.btn-primary type='submit'
        = t('actions.save_changes')